<?php
$lite = isset($_GET["lite"]);
use PFBC\Form;
use PFBC\Element;
use PFBC\View;
use PFBC\Validation;

use documongo\MongoObject\Document;
use documongo\MongoObject\DocumentType;

require_once('lib/fconnect.php');
$db = DBConnect::getInstance();

require_once('lib/frole.php');
$role = new Role();
$role->isPageEnable($user->uuid);


$fields = $db->colModel->findOne(array('name'=>'chair'));
$chairs = $db->colDocs->find(array('type'=>'chair'))->sort(['parent' => 1, 'title_ru' => 1]);
$faculties_raw = $db->colDocs->find(array('type'=>'faculty'));

$fac_parse = function($facs_raw) {
	$facs = [];
	foreach($facs_raw as $fac) {
		$facs[$fac["uuid"]] = $fac;
	}
	return $facs;
};
$faculties = $fac_parse($faculties_raw);


$out = '';

$modes = ["2d", "1d"];
$mode = isset($_GET["mode"]) && in_array($_GET["mode"], $modes) ? $_GET["mode"] : reset($modes);

$show_faculty = isset($_GET["show_faculty"]) ? (boolean)$_GET["show_faculty"] : false;

if ($mode == "2d") {
	$out .= '<tr>'
		. '<td class="chairname" nowrap><b>Название</b></td>'
		. ($show_faculty
			? '<td><b>Факультет</b></td>'
			: '')
		. '';

	foreach($fields['items'] as $item){
		if(isset($item['pdf']) && $item['pdf']){
			$items[$item['name']]['label'] = $item['label_ru'];
			$items[$item['name']]['index_code'] = $item['index_code_ru'];
			if(isset($item['accumulative'])){
				if($item['accumulative']){
					$items[$item['name']]['accumulative'] = true;
				}else{
					$items[$item['name']]['accumulative'] = false;
				}
			}
			$out .= '<td>' . (isset($item['index_code_ru']) ? ($item['index_code_ru'] . ' ') : '') . '<b>'.$item['label_ru'].'</b></td>';
		}
	}
	$out .= '</tr>';
	foreach($chairs as $chair){
		$out .= '<tr>'
			. '<td class="chairname" nowrap>'.$chair['title_ru'].'</td>'
			. ($show_faculty
				? (''
					. '<td class="chairname" nowrap>'.$faculties[$chair['parent']]['title_ru'].'</td>'
					. '')
				: '')
			. '';

		foreach($items as $key => $item){
			if(isset($item['accumulative'])){
				if($item['accumulative']){
					if(isset($chair[$key])){
						$out .= '<td>'.$chair[$key].'</td>';
					}else{
						$out .= '<td></td>';
					}
				}else{
					$counter = 0;
					$val = 0;
					if(isset($chair[$key])){
						$val += $chair[$key];
					}
					if(isset($chair['versions'])){
						foreach($chair['versions'] as $version){
							$counter++;
							// if($counter < 10) continue;
							if(isset($version['content'][$key])){
								$val += $version['content'][$key];
								//$val .= '+' .$version['content'][$key];
							}
						}
					}
					$out .='<td>'.$val.'</td>';
				}
			}else{
				$out .= '<td></td>';
			}
		}
		$out .= '</tr>';
	}
} elseif ($mode == "1d") {
	foreach($fields['items'] as $item){
		if(isset($item['pdf']) && $item['pdf']){
			$items[$item['name']]['label'] = $item['label_ru'];
			$items[$item['name']]['index_code'] = $item['index_code_ru'];
			if(isset($item['accumulative'])){
				if($item['accumulative']){
					$items[$item['name']]['accumulative'] = true;
				}else{
					$items[$item['name']]['accumulative'] = false;
				}
			}
		}
	}
	foreach($chairs as $chair){
		foreach($items as $key => $item){
			$out .= '<tr><td class="chairname" nowrap>'.$chair['title_ru'].'</td>';
			$out .= '<td class="chairname" nowrap>'.(isset($item['index_code']) ? ($item['index_code'] . ' ') : '').$item['label'].'</td>';
			if(isset($item['accumulative'])){
				if($item['accumulative']){
					if(isset($chair[$key])){
						$out .= '<td>'.$chair[$key].'</td>';
					}else{
						$out .= '<td></td>';
					}
				}else{
					$counter = 0;
					$val = 0;
					if(isset($chair[$key])){
						$val += $chair[$key];
					}
					if(isset($chair['versions'])){
						foreach($chair['versions'] as $version){
							$counter++;
							if($counter < 10) continue;
							if(isset($version['content'][$key])){
								$val += $version['content'][$key];
							}
						}
					}
					$out .='<td>'.$val.'</td>';
				}
			}else{
				$out .= '<td></td>';
			}
			$out .= '</tr>';
		}
	}
}

?><!doctype html>


<html lang="ru">
	<head>
		<meta charset="utf-8" />
		<title>Просмотр всех данных</title>
		<link rel="stylesheet" href="/css/jquery-ui.css" />
		<script src="/js/jquery-1.9.1.js"></script>
		<script src="/js/jquery-ui.js"></script>
		<script src="/js/jquery.form.js"></script>
		<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
		<script src="/js/bootstrap.min.js"></script>
		<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
		<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
		<link rel="stylesheet" href="/css/admin.css" />
		<link rel="stylesheet" href="/css/navigation__horizontal.css" />
		<link rel="stylesheet" href="/css/overview.table.css" />
		<script src="/js/overview.table.js"></script>
		<script src="/js/auth.js"></script>

		<style>
			.main-page__content {
				margin-top: 60px;
				font-size: 2em;
				text-align: center;
			}

			#all_data{
				border: 1px solid black;
			}
			#all_data td{
					text-align:center;
					border: 1px solid black;
			}
			td.chairname{
				width:600px;
				text-align:left!important;
			}
		</style>

		<script>
			var language = "<?=$language?>";
			var pageType = "<?=$pageType?>";

		</script>
	</head>

	<body>
	<div>
	<table id="all_data">
	<?=$out;?>
	</table>
	</div>
	</body>
</html>
